/* Copyright (C) Stephen Chung, 1995.  All rights reserved. */

#include "jwp.h"
#include "idm.h"
#include <ddeml.h>


static DDEInstance = NULL;


static BOOL ProcessDDECommand (char *buffer)
{
    char word[MAXLINELEN];
    char remains[MAXLINELEN];

    sprintf(word, "DDE Command: <%s>", buffer);
    StatusMessage(word);

    word[0] = remains[0] = '\0';
    sscanf(buffer, "%s %[^\n]", word, remains);

    if (!stricmp(word, "OpenFile")) {
        int Opened = 0;

        while (remains[0]) {
            strcpy(buffer, remains);
            word[0] = remains[0] = '\0';
            sscanf(buffer, "%s %[^\n]", word, remains);

#ifdef USEWIN32
            if (word[0] == '\"') {
                word[0] = remains[0] = '\0';
                sscanf(buffer, "%*[\"]%[^\n\"]%*[\"] %[^\n]", word, remains);
            }
#endif USEWIN32

            if (!DoFileOpen(word))
                ErrorMessage(global.hwnd, "Cannot open file '%s'.", word);
            else
                Opened++;
        }

        return (Opened > 0);
    }

    return (FALSE);
}



HDDEDATA CALLBACK DDEProc (UINT type, UINT fmt, HCONV hconv, HSZ hsz1, HSZ hsz2,
                           HDDEDATA hData, DWORD dwData1, DWORD dwData2)
{
    switch (type) {
        case XTYP_EXECUTE: {
            char buffer[MAXLINELEN];

            if (DdeGetData(hData, buffer, MAXLINELEN, 0) != DMLERR_NO_ERROR) {
                return (DDE_FNOTPROCESSED);
            }

            if (ProcessDDECommand(buffer)) return (DDE_FACK);
            return (DDE_FNOTPROCESSED);
        }
    }

    return (NULL);
}


BOOL InitDDE (BOOL finish)
{
    if (!finish) {
        if (DdeInitialize(&DDEInstance, DDEProc,
                          CBF_FAIL_ADVISES | CBF_FAIL_CONNECTIONS |
CBF_FAIL_POKES | CBF_FAIL_REQUESTS | CBF_SKIP_ALLNOTIFICATIONS,
                          0L) != DMLERR_NO_ERROR) return (FALSE);
        return (TRUE);
    } else {
        return (DdeUninitialize(DDEInstance));
    }
}
